



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>初始js闭包&amp;事件的冒泡和捕获&amp;EVENT对象</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">初始js闭包&amp;事件的冒泡和捕获&amp;EVENT对象</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 12:41:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一.初识闭包</strong></p>
<div><code>function</code> <code>a(){</code></div>
<div><code>&nbsp;&nbsp;</code><code>var</code> <code>n = 0;</code></div>
<div><code>&nbsp;&nbsp;</code><code>this</code><code>.inc = </code><code>function</code> <code>() {</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>n++; </code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>console.log(n);</code></div>
<div><code>&nbsp;&nbsp;</code><code>};</code></div>
<div><code>}</code></div>
<div><code>var</code> <code>c = </code><code>new</code> <code>a();</code></div>
<div><code>c.inc();&nbsp; </code><code>//控制台输出1</code></div>
<div><code>c.inc();&nbsp; </code><code>//控制台输出2</code></div>
<div>
<p><strong>什么是闭包？这就是闭包！</strong></p>
<p>有权访问另一个函数作用域内变量的函数都是闭包。这里 inc 函数访问了构造函数 a 里面的变量 n，所以形成了一个闭包。</p>
<p>function a(){<br />&nbsp;&nbsp;var n = 0;<br />&nbsp;&nbsp;function inc(){<br />&nbsp;&nbsp;&nbsp;&nbsp;n++; <br />&nbsp;&nbsp;&nbsp;&nbsp;console.log(n);<br />&nbsp;&nbsp;}<br />&nbsp;&nbsp;return inc;<br />}<br />var c = a();<br />c();&nbsp; //控制台输出1<br />c();&nbsp; //控制台输出2</p>
<p>var c = a()，这一句 a()返回的是函数 inc，那这句等同于 var c = inc;</p>
<p>c()，这一句等同于 inc();&nbsp;&nbsp;<strong>注意</strong>，函数名只是一个标识（指向函数的指针），而()才是执行函数。</p>
<p>后面三句翻译过来就是：&nbsp; var c = inc;&nbsp; inc();&nbsp; inc();</p>
<p><strong>为啥要这样写？</strong><br />我们知道，js的每个函数都是一个小黑屋，它可以获取外界信息，但是外界却无法直接看到里面的内容。将变量 n 放进小黑屋里，除了 inc 函数之外，没有其他办法能接触到变量 n，而且在函数 a 外定义同名的变量 n 也是互不影响的，这就是所谓的增强&ldquo;封装性&rdquo;。</p>
<p>而之所以要用 return 返回函数标识 inc，是因为在 a 函数外部无法直接调用 inc 函数，所以 return inc 与外部联系起来，代码 2 中的 this 也是将 inc 与外部联系起来而已。</p>
<p><strong>常见的陷阱</strong></p>
<div><code>function</code> <code>createFunctions(){</code></div>
<div><code>&nbsp;&nbsp;</code><code>var</code> <code>result = </code><code>new</code> <code>Array();</code></div>
<div><code>&nbsp;&nbsp;</code><code>for</code> <code>(</code><code>var</code> <code>i=0; i &lt; 10; i++){</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>result[i] = </code><code>function</code><code>(){</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code> <code>i;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>};</code></div>
<div><code>&nbsp;&nbsp;</code><code>}</code></div>
<div><code>&nbsp;&nbsp;</code><code>return</code> <code>result;</code></div>
<div><code>}</code></div>
<div><code>var</code> <code>funcs = createFunctions();</code></div>
<div><code>for</code> <code>(</code><code>var</code> <code>i=0; i &lt; funcs.length; i++){</code></div>
<div><code>&nbsp;&nbsp;</code><code>console.log(funcs[i]);</code></div>
<div><strong><code>}</code></strong></div>
<div><strong>实际的执行过程：</strong></div>
<div>
<div><em><code>var</code> <code>result = </code><code>new</code> <code>Array(), i;</code></em></div>
<div><em><code>result[0] = </code><code>function</code><code>(){ </code><code>return</code> <code>i; }; </code><code>//没执行函数，函数内部不变，不能将函数内的i替换！</code></em></div>
<div><em><code>result[1] = </code><code>function</code><code>(){ </code><code>return</code> <code>i; }; </code><code>//没执行函数，函数内部不变，不能将函数内的i替换！</code></em></div>
<div><em><code>...</code></em></div>
<div><em><code>result[9] = </code><code>function</code><code>(){ </code><code>return</code> <code>i; }; </code><code>//没执行函数，函数内部不变，不能将函数内的i替换！</code></em></div>
<div><em><code>i = 10;</code></em></div>
<div><em><code>funcs = result;</code></em></div>
<div><em><code>result = </code><code>null</code><code>;</code></em></div>
<div><em>&nbsp;</em></div>
<div><em><code>console.log(i); </code><code>// funcs[0]()就是执行 return i 语句，就是返回10</code></em></div>
<div><em><code>console.log(i); </code><code>// funcs[1]()就是执行 return i 语句，就是返回10</code></em></div>
<div><em><code>...</code></em></div>
<div><em><code>console.log(i); </code><code>// funcs[9]()就是执行 return i 语句，就是返回10</code></em></div>
</div>
<div>闭包就是一个函数引用另外一个函数的变量，因为变量被引用着所以不会被回收，因此可以用来封装一个私有变量。这是优点也是缺点，<strong>不必要的闭包只会徒增内存消耗！</strong>另外使用闭包也要注意变量的值是否符合你的要求，因为他就像一个静态私有变量一样。闭包通常会跟很多东西混搭起来，接触多了才能加深理解，这里只是开个头说说基础性的东西。</div>
</div>
<p><strong>二.事件的冒泡和捕获</strong></p>
<p>（1）冒泡型事件：事件按照从最特定的事件目标到最不特定的事件目标(document对象)的顺序触发。</p>
<p>（2）捕获型事件(event capturing)：事件从最不精确的对象(document 对象)开始触发，然后到最精确(也可以在窗口级别捕获事件，不过必须由开发人员特别指定。</p>
<p>支持W3C标准的浏览器在添加事件时用addEventListener(event,fn,useCapture)方法，基中第3个参数useCapture是一个Boolean值，用来设置事件是在事件捕获（true）时执行，还是事件冒泡（false）时执行。而不兼容W3C的浏览器(IE)用attachEvent()方法，此方法没有相关设置，不过IE的事件模型默认是在事件冒泡时执行的，也就是在useCapture等于false的时候执行，所以把在处理事件时把useCapture设置为false是比较安全，也实现兼容浏览器的效果。</p>
<p>（3）DOM事件流：同时支持两种事件模型：捕获型事件和冒泡型事件，但是，捕获型事件先发生。两种事件流会触及DOM中的所有对象，从document对象开始，也在document对象结束。</p>
<p>DOM事件模型最独特的性质是，文本节点也触发事件(在IE中不会)。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1019408/201711/1019408-20171102165525201-1288079956.png" /></p>
<p>支持W3C标准的浏览器在添加事件时用addEventListener(event,fn,useCapture)方法，基中第3个参数useCapture是一个Boolean值，用来设置事件是在事件捕获时执行，还是事件冒泡时执行。而不兼容W3C的浏览器(IE)用attachEvent()方法，此方法没有相关设置，不过IE的事件模型默认是在事件冒泡时执行的，也就是在useCapture等于false的时候执行，所以把在处理事件时把useCapture设置为false是比较安全，也实现兼容浏览器的效果。</p>
<p>&lt;body&gt;<br />		&lt;div id = "div" &gt;<br />			　　&lt;p id = "p" &gt;事件的冒泡和捕获&lt;/p&gt;<br />		&lt;/div&gt;<br />	&lt;/body&gt;<br />	&lt;script type="text/javascript"&gt;<br />		　　document.getElementById("div").addEventListener('click',function(){<br />				　　　　alert("parent");<br />		　　},true);<br />		　　document.getElementById("p").addEventListener('click',function(){<br />				　　　　alert("child");<br />		　　},true);<br />	&lt;/script&gt;</p>
<p>w3c中，在捕获的过程中stopPropagation（）；后，后面的冒泡过程也不会发生了~</p>
<p>document.getElementById("p").addEventListener('click',function(event){<br />			　　event.stopPropagation();<br />			　　alert("child");<br />		},false);</p>
<p>三.event对象</p>
<p>Event属性和方法：</p>
<p>1. type：事件的类型，如onlick中的click；</p>
<p>2. srcElement/target：事件源，就是发生事件的元素；</p>
<p>3. button：声明被按下的鼠标键，整数，1代表左键，2代表右键，4代表中键，如果按下多个键，酒把这些值加起来，所以3就代表左右键同时按下；（firefox中 0代表左键，1代表中间键，2代表右键）</p>
<p>4. clientX/clientY：事件发生的时候，鼠标相对于浏览器窗口可视文档区域的左上角的位置；(在DOM标准中，这两个属性值都不考虑文档的滚动情况，也就是说，无论文档滚动到哪里，只要事件发生在窗口左上角，clientX和clientY都是 0，所以在IE中，要想得到事件发生的坐标相对于文档开头的位置，要加上<br />document.body.scrollLeft和 document.body.scrollTop)</p>
<p>5. offsetX,offsetY/layerX,layerY：事件发生的时候，鼠标相对于源元素左上角的位置；</p>
<p>6. x,y/pageX,pageY：检索相对于父要素鼠标水平坐标的整数；</p>
<p>7. altKey,ctrlKey,shiftKey等：返回一个布尔值；</p>
<p>8. keyCode：返回keydown何keyup事件发生的时候按键的代码，以及keypress 事件的Unicode字符；(firefox2不支持 event.keycode，可以用 event.which替代 )</p>
<p>9. fromElement,toElement：前者是指代mouseover事件中鼠标移动过的文档元素，后者指代mouseout事件中鼠标移动到的文档元素；</p>
<p>10. cancelBubble：一个布尔属性，把它设置为true的时候，将停止事件进一步起泡到包容层次的元素；(e.cancelBubble = true; 相当于 e.stopPropagation();)</p>
<p>11. returnValue：一个布尔属性，设置为false的时候可以组织浏览器执行默认的事件动作；(e.returnValue = false; 相当于 e.preventDefault();)</p>
<p>12. attachEvent(),detachEvent()/addEventListener(),removeEventListener：为制定 DOM对象事件类型注册多个事件处理函数的方法，它们有两个参数，第一个是事件类型，第二个是事件处理函数。在<br />attachEvent()事件执行的时候，this关键字指向的是window对象，而不是发生事件的那个元素；</p>
<p>13. screenX、screenY：鼠标指针相对于显示器左上角的位置，如果你想打开新的窗口，这两个属性很重要；</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jzkee8.html">JavaScript摇股子</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyrjmx8.html">初始化git远程仓库步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1dy25q.html">欲哭无泪的&commat;Autowired注入对象为NULL</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8orzgl8.html">background-clip 制作文字火焰效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qym6odq.html">Quartz&period;NET syudy</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1mk0x8.html">&lbrack;ios&rsqb;离屏渲染优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnno16q.html">not use jquery</a>
		</li>
						<li><a href="https://www.batexi.com/a/96opd0y9.html">修复Dll文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdr37z8.html">12 Useful &OpenCurlyDoubleQuote;df&rdquo; Commands to Check Disk Space in Linux</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wgdj3q.html">c语言中文件的操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmx0dk9.html">Redis和Memcache的区别分析 &lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzew1e8.html">Android内存性能优化&lpar;内部资料总结&rpar; 转</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y7lo08.html">Unity3D 中材质球&lpar;Material&rpar;预制体打包成AB&lpar;AssetBundle&rpar;出现材质丢失问题的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mek1epq.html">MySQL如何记录binlog</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mev7l0q.html">BZOJ 2969&colon; 矩形粉刷（期望）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjx2gk8.html">js操作中要去注意的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oml118.html">爱因斯坦求和约定 &lpar;Einstein summation convention&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gmz20q.html">Golang入门教程（四）变量声明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1wr3pq.html">【bzoj1901】dynamic ranking（带修改主席树&sol;树套树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o5zvg8.html">css display属性</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/960pjzj9.html">java&plus;Selenium&plus;TestNg搭建自动化测试架构&lpar;1&rpar;实现代码和数据的分离</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv215yy9.html">spring整合thymeleaf</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g0xomq.html">【转载】Google 程序员消灭 Bug 的 5 大法宝！</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv211mo9.html">Btrace官方教程-中文版</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwddz78.html">python：windows下python2&period;7安装mysql-python失败【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rmr4n9.html">spring 2&period;5&period;6 错误：Context namespace element &amp;&num;39&semi;component-scan&amp;&num;39&semi; and its parser class &lbrack;org&period;springframework&period;context&period;annotation&period;ComponentScanBeanDefinitionParser&rsqb; are only available on JDK 1&period;5 and higher</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvjlwr8.html">由2个鸡蛋从100层楼下落到HashMap的算法优化联想</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjepy09.html">void类型及void指针（转载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1j4exq.html">从客户端出现小于等于公式符号引发检测到有潜在危险的Request&period;Form 值</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25jk7lq.html">使用idea建立逆向工程</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
